package com.eco.plugin.gfkdsso.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "Plugin-Config-Title")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.eco.plugin.wink.gfkdsso", text = "Plugin-Config-Title", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "ssoUrl", name = "Plugin-Config-ssoUrl", description = "Plugin-Config-ssoUrl", status = Status.SHOW)
    private Conf<String> ssoUrl = Holders.simple("");

    @Identifier(value = "userserviceid", name = "Plugin-Config-userserviceid", description = "Plugin-Config-userserviceid", status = Status.SHOW)
    private Conf<String> userserviceid = Holders.simple("");

    @Identifier(value = "logoutserviceid", name = "Plugin-Config-logoutserviceid", description = "Plugin-Config-logoutserviceid", status = Status.SHOW)
    private Conf<String> logoutserviceid = Holders.simple("http://localhost:8075/webroot/decision");

    @Identifier(value = "logoutUrl", name = "Plugin-Config-logoutUrl", description = "Plugin-Config-logoutUrl", status = Status.SHOW)
    private Conf<String> logoutUrl = Holders.simple("");


    public String getSsoUrl() {
        return ssoUrl.get();
    }

    public void setssoUrl(String url) {
        this.ssoUrl.set(url);
    }

    public String getUserserviceid() {
        return userserviceid.get();
    }

    public void setUserserviceid(String url) {
        this.userserviceid.set(url);
    }

    public String getLogoutserviceid() {
        return logoutserviceid.get();
    }

    public void setLogoutserviceid(String url) {
        this.logoutserviceid.set(url);
    }

    public String getLogoutUrl() {
        return logoutUrl.get();
    }

    public void setLogoutUrl(String url) {
        this.logoutUrl.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
